
; Copy $C000-$FFFF to $4000-$7FFF
; Input: A (rom bank)
; Code uses ZP addresses 2,3,4,5 for pointers
; Code is position independent
; Build with acme assembler
; acme -v3 -f cbm --cpu w65c02 -I ../ --report report.txt -o innerloop.prg romdump-innerloop-v2.asm

*=$0400

ZP_SRC_PTR=2
ZP_DEST_PTR=4

    ldx 1 ; preserve basic rom bank

    sta 1 ; set rom bank from A ($030C)

    lda #$C0
    sta ZP_SRC_PTR+1
    lda #$40
    sta ZP_DEST_PTR+1
    ldy #0
    stz ZP_SRC_PTR
    stz ZP_DEST_PTR
loop:
    lda (ZP_SRC_PTR),y
    sta (ZP_DEST_PTR),y
    iny
    bne loop
    
    inc ZP_DEST_PTR+1
    inc ZP_SRC_PTR+1
    bne loop

    stx 1 ; restore basic rom bank

    rts

