100 REM VERA FLASH DUMPER, BY EIRIK STOPLE
110 F$ = "VERADMP.BIN"
120 POKE $9F3F,$00 : REM ENSURE SPI CHIP SELECT IS OFF
130 PRINT "VERA FLASH DUMP, 128 KB, TO " F$ : PRINT
140 PRINT "THIS WILL TAKE 4 MINUTES.": PRINT
150 PRINT "NB: TAKE A BACKUP OF YOUR SD CARD FIRST!": PRINT
160 INPUT "CONNECT VERA JUMPER. CONTINUE OR ABORT? (C/A)"; B$
170 IF B$ <> "C" THEN END
180 REM
200 GOSUB 3000 : REM REQUEST JEDEC ID
290 IF D <> $EF4015 THEN PRINT "MISMATCH, ABORTING" : END
300 PRINT "OK"
310 REM
400 PRINT "READING FROM START OF VERA FLASH TO BANK 1-16:A000-BFFF..."
410 POKE $9F3F,$01 : REM SPI CHIP SELECT ON
420 POKE $9F3E,$03 : REM CMD: READ DATA
430 POKE $9F3E,$00 : REM ADDRH = 0
440 POKE $9F3E,$00 : REM ADDRM = 0
450 POKE $9F3E,$00 : REM ADDRL = 0
460 REM
500 REM DUMP TO BANK 1-16:A000-BFFF
510 FOR I = 1 TO 16
520 PRINT "BANK " I
530 BANK I
535 REM BASIC LOOP TAKES 13 SECOND PR BANK
540 FOR J = $A000 TO $BFFF : POKE $9F3E,0 : POKE J,PEEK($9F3E) : NEXT J
550 NEXT I
560 REM
570 POKE $9F3F,$00 : REM CHIP SELECT OFF
580 REM
600 INPUT "REMOVE VERA JUMPER. CONTINUE OR ABORT? (C/A)"; B$
610 IF B$ <> "C" THEN END
630 GOSUB 3000 : REM REQUEST JEDEC ID
640 IF D = $EF4015 THEN PRINT "MISMATCH, TRY AGAIN" : GOTO 570
650 REM
700 PRINT "DUMP RAM BANKS TO FILE"
710 REM WARNING: DUE TO A BUG IN KERNAL <= R48, NEVER APPEND TO AN EMPTY
720 REM OR NON-EXISTING FILE
730 BSAVE "@:" + F$,8,1,$A000,$C000
740 FOR I = 2 TO 16 : BSAVE F$ + ",S,A",8,I,$A000,$C000 : NEXT I
750 PRINT "VERA FLASH SUCCESSFULLY DUMPED TO " F$
760 END
3000 REM SUBROUTINE: REQUEST JEDEC ID FROM VERA FLASH
3010 PRINT "VERIFY JEDEC ID... ";
3020 POKE $9F3F,$01 : REM SPI CHIP SELECT ON
3030 POKE $9F3E,$9F : REM CMD: GET JEDEC ID
3040 POKE $9F3E,$00 : A = PEEK($9F3E) : REM SPI READ, MANUFACTURER
3050 POKE $9F3E,$00 : B = PEEK($9F3E) : REM SPI READ, ID H
3060 POKE $9F3E,$00 : C = PEEK($9F3E) : REM SPI READ, ID L
3070 POKE $9F3F,$00 : REM CHIP SELECT OFF
3080 D = A * $10000 + B * $100 + C
3090 PRINT "$" HEX$(A) HEX$(B) HEX$(C)
3100 RETURN
