100 REM VERA FLASH DUMPER, BY EIRIK STOPLE
110 F$ = "VERADPFO.BIN"
130 PRINT "VERA FLASH DUMP, 2 MB, OPTIMIZED, TO " F$ : PRINT
131 POKE $030F, 1 : REM SET CARRY FLAG
132 SYS $FF99 : REM MEMTOP, RETURN USABLE MEM BANKS IN A (64/128/0(256))
133 G = PEEK($030C)
134 IF G = 0 THEN G = 256 : REM G IS 64/128/256
135 IF G < 64 THEN PRINT "NOT ENOUGH RAM" : END
136 IF G < 128 THEN G = 64: GOTO 140
137 IF G < 256 THEN G = 128: GOTO 140
140 PRINT "RAM BANKS AVAILABLE:" G ". USING" (G/64) "HIGH RAM IC"
145 PRINT: PRINT "READING TAKES 10 SECONDS, WRITE TO FILE: 1 MINUTE": PRINT
150 PRINT "NB: TAKE A BACKUP OF YOUR SD CARD FIRST!": PRINT
156 E = 0 : REM BANK OFFSET, 0/64/128/192
157 GOSUB 2000 : REM LOAD OPTIMIZED LOOP
158 REM
160 POKE $9F3F,$00 : REM ENSURE SPI CHIP SELECT IS OFF
161 INPUT "CONNECT VERA JUMPER. CONTINUE OR ABORT? (C/A)"; B$
170 IF B$ <> "C" THEN END
180 REM
190 GOSUB 3000 : REM REQUEST JEDEC ID
290 IF D <> $EF4015 THEN PRINT "MISMATCH, TRY AGAIN" : GOTO 160
300 PRINT "OK"
310 REM
400 PRINT "READING FROM VERA FLASH TO 6000-7FFF AND BANKED A000-BFFF..."
410 POKE $9F3F,$01 : REM SPI CHIP SELECT ON
420 POKE $9F3E,$03 : REM CMD: READ DATA
430 POKE $9F3E,(E / 8) : REM ADDRH = 0-8-16-24 (OR H)
440 POKE $9F3E,$00 : REM ADDRM = 0
450 POKE $9F3E,$00 : REM ADDRL = 0
460 REM
500 REM DUMP 64/128/256 CHUNKS OF 8192 BYTES FROM FLASH TO RAM
510 FOR I = 0 TO (G - 1)
520 PRINT "READ" (E + I)
521 IF I =  0 THEN POKE 5,$60 :          REM STORE FIRST CHUNK TO 6000-7FFF
522 IF I <> 0 THEN POKE 5,$A0 : BANK I : REM STORE CHUNKS TO A000-BFFF
540 SYS $400
550 NEXT I
560 REM
570 POKE $9F3F,$00 : REM CHIP SELECT OFF
580 REM
600 INPUT "REMOVE VERA JUMPER. CONTINUE OR ABORT? (C/A)"; B$
610 IF B$ <> "C" THEN END
620 REM
630 GOSUB 3000 : REM REQUEST JEDEC ID
640 IF D = $EF4015 THEN PRINT "MISMATCH, TRY AGAIN" : GOTO 570
650 PRINT "OK"
700 PRINT "DUMP RAM BANKS TO FILE..."
710 REM WARNING: DUE TO A BUG IN KERNAL <= R48, NEVER APPEND TO AN EMPTY
720 REM OR NON-EXISTING FILE
730 IF E = 0 THEN BSAVE "@:" + F$,8,1,$6000,$8000 : GOTO 750 : REM FIRST BANK
740 BSAVE F$ + ",S,A",8,1,$6000,$8000 : REM APPEND
750 FOR I = 1 TO (G - 1) : BSAVE F$ + ",S,A",8,I,$A000,$C000 : NEXT I
760 E = E + G
770 PRINT "BANKS DUMPED:" E "OF 256"
780 IF E < 256 THEN GOTO 160
800 PRINT "VERA FLASH SUCCESSFULLY DUMPED TO " F$
810 END
1000 REM OPTIMIZED SPI READ FUNCTION, POSITION-INDEPENDENT CODE
1010 REM ADDR 5: HIGH DEST ADDRESS, MUST BE SPECIFIED BY USER
1020 REM                ZP.DEST.PTR=4
1050 DATA $64,$04     : REM STZ ZP.DEST.PTR ; ASSUME USER HAVE SET HIGH ADDR
1060 DATA $A2,$20     : REM LDX #$20 ; NUMBER OF 256 BYTE BLOCKS TO COPY
1070 DATA $A0,$00     : REM LDY #0
1080 DATA $9C,$3E,$9F : REM LOOP: STZ VERA.SPI.DATA ; TRANSFER SPI
1100 DATA $2C,$3F,$9F : REM BUSY: BIT VERA.SPI.CTRL
1120 DATA $30,$FB     : REM BMI BUSY
1130 DATA $AD,$3E,$9F : REM LDA VERA.SPI.DATA ; GET RESULT
1150 DATA $91,$04     : REM STA (ZP.DEST.PTR),Y
1160 DATA $C8         : REM INY
1170 DATA $D0,$F0     : REM BNE LOOP
1180 DATA $E6,$05     : REM INC ZP.DEST.PTR+1
1190 DATA $CA         : REM DEX
1200 DATA $D0,$EB     : REM BNE LOOP
1210 DATA $60         : REM RTS
2000 REM SUBROUTINE: COPY OPTIMIZED LOOP TO $400
2010 FOR X=0 TO 27: READ A: POKE $400+X,A: NEXT X
2020 RETURN
3000 REM SUBROUTINE: REQUEST JEDEC ID FROM VERA FLASH
3010 PRINT "VERIFY JEDEC ID... ";
3020 POKE $9F3F,$01 : REM SPI CHIP SELECT ON
3030 POKE $9F3E,$9F : REM CMD: GET JEDEC ID
3040 POKE $9F3E,$00 : A = PEEK($9F3E) : REM SPI READ, MANUFACTURER
3050 POKE $9F3E,$00 : B = PEEK($9F3E) : REM SPI READ, ID H
3060 POKE $9F3E,$00 : C = PEEK($9F3E) : REM SPI READ, ID L
3070 POKE $9F3F,$00 : REM CHIP SELECT OFF
3080 D = A * $10000 + B * $100 + C
3090 PRINT "$" HEX$(A) HEX$(B) HEX$(C)
3100 RETURN
